#ifndef JETSTREAM_GLOBAL_CONSTANTS_PY
#define JETSTREAM_GLOBAL_CONSTANTS_PY
#define __unused_constants_start() \
""" "
namespace Constants { enum : int { //" """
#if 0
Constants = type('Constants', (object, ), (lambda
#else

version_major = 2,
version_minor = 9,
version_subminor = 4,
api_version = 42,

default_api_port = 8886,

transfer_origin_unknown = 0,
transfer_origin_gui = 1,
transfer_origin_api = 2,
transfer_origin_python = 3,

transfer_flags_none              = 0,
transfer_flags_read              = 1<<0,
transfer_flags_write             = 1<<1,
transfer_flags_read_write        = (1<<2)-1,
transfer_flags_write_mtime       = 1<<2,
transfer_flags_write_only_newer  = 1<<3,
transfer_flags_skip_error_files  = 1<<4,
transfer_flags_mask              = (1<<5)-1,

overwrite_in_place_same_size   = 2,
overwrite_never                = 3,
overwrite_always               = 4,
overwrite_versioned            = 5,

symlinks_ignore        = 0,
symlinks_copy_contents = 1<<0,

file_type_directory    = 2,
file_type_regular_file = 4,

min_cipher_none          = 0,
min_cipher_unencrypted   = 1,
min_cipher_encrypted_128 = 2,
min_cipher_encrypted_256 = 3

#endif
#if 0
:locals())())
#endif

#define __unused_permissions_start() \
""" "
}; enum : unsigned long long { //" """
#if 0
Permissions = type('Permissions', (object, ), (lambda
#else

permission_none                     = 0,
allow_API_file_create               = (0x0000000000000001 << 0),
allow_API_file_list                 = (0x0000000000000001 << 1),
allow_API_file_read                 = (0x0000000000000001 << 2),
allow_API_file_change               = (0x0000000000000001 << 3),
allow_API_file_delete               = (0x0000000000000001 << 4),
allow_API_manifest_create           = (0x0000000000000001 << 5),
allow_API_manifest_list             = (0x0000000000000001 << 6),
allow_API_manifest_change           = (0x0000000000000001 << 7),
allow_API_manifest_delete           = (0x0000000000000001 << 8),
allow_API_destination_create        = (0x0000000000000001 << 9),
allow_API_destination_list          = (0x0000000000000001 << 10),
allow_API_destination_change        = (0x0000000000000001 << 11),
allow_API_destination_delete        = (0x0000000000000001 << 12),
allow_API_transfer_create           = (0x0000000000000001 << 13),
allow_API_transfer_list             = (0x0000000000000001 << 14),
allow_API_transfer_change           = (0x0000000000000001 << 15),
allow_API_transfer_delete           = (0x0000000000000001 << 16),
allow_API_shared_token_create       = (0x0000000000000001 << 17),
allow_API_shared_token_list         = (0x0000000000000001 << 18),
allow_API_shared_token_change       = (0x0000000000000001 << 19),
allow_API_shared_token_delete       = (0x0000000000000001 << 20),
allow_API_api_token_create          = (0x0000000000000001 << 21),
allow_API_api_token_list            = (0x0000000000000001 << 22),
allow_API_api_token_change          = (0x0000000000000001 << 23),
allow_API_api_token_delete          = (0x0000000000000001 << 24),
allow_API_recv_source_list          = (0x0000000000000001 << 25),
allow_API_recv_transfer_list        = (0x0000000000000001 << 26),
allow_API_discover_packet_ops       = (0x0000000000000001 << 27),
allow_API_event_log_read            = (0x0000000000000001 << 28),
allow_API_ping_ops                  = (0x0000000000000001 << 29),
allow_API_watch_folder_create       = (0x0000000000000001 << 30),
allow_API_watch_folder_list         = (0x0000000100000000 >> 1),
allow_API_watch_folder_change       = (0x0000000100000000 << 0),
allow_API_watch_folder_delete       = (0x0000000100000000 << 1),
permission_all_API                  = (0x0000000100000000 << 2) - 1,

permission_super_user               = 0x8000000000000000,
permission_wrangler                 = (0x8000000000000000 >> 2),
permission_all_escalated_privileges = (0x8000000000000000 | (0x8000000000000000 >> 2)),

allow_API_wrangler                  = (0x8000000000000000 >> 3),

allow_receive_files                 = (0x8000000000000000 >> 1),
permission_all_receive              = (0x8000000000000000 >> 1)

#endif
#if 0
:locals())())
#endif
#define __unused_constants_end() \
""" "
}; }

// API version history:
// 15 - [released 1.4.1]
// 16 - createDestination sender port default changed (no multiplex)
// 17 - added setRateControlMethodAsync [released 1.4.2]
// 18 - added updateTransferDefaults [released 1.4.3]
// 19 - added rmAsync and mvAsync; change 'username' to 'userName' in getServerInfo
// 20 - added get/set/deleteSandboxMapping [released 1.5.0]
// 21 - added 'mappings' parameter to createManifest [released 1.5.1]
// 22 - added setBandwidthLimits [released 1.6.0]
// 23 - added 'sendRateMax' and 'priorityLane' to transfers; 'priorityLanes' to Destinations [released 1.6.1]
// 24 - replaced setBandwidthLimits with updateBandwidthLimits; added error types [released 1.6.3]
// 25 - replaced "sandboxed" with "user.sandboxed" in getServerInfo; added overwrite modes;
//      removed getDestinationId, enableRateControlAsync, setRateControlMethodAsync, setSendRateMinAsync, setSendRateAsync;
//      added getConnection, getConnections, updateConnectionParamsAsync; updated params of createDestination [released 1.7.0]
// 26 - added garbageCollect; added s3 and netShare sandboxes [released 1.8.0]
// 27 - added createManifest parameters: 'symlinkOptions', 'flags', 'access' [released 1.9.0]
// 28 - added setLicenseKeyAsync [released 2.1.0]
// 29 - added minCipher [released 2.2.0]
// 30 - added transfer_flags_write_mtime/transfer_flags_write_only_newer; renamed overwrite modes; added 'mtime' to ls/lsRoot/getManifestFiles;
//      added 'fileTimeResolutionMicroseconds', 'timeoutSeconds', 'userData' to createTransfer; added 'permanent' to createDestination [released 2.3.0]
// 31 - added permission flags; added createAPIToken, deleteAPIToken, etc.; added 'token' to createTransfer; added 'permissions' to getServerInfo and tokens [released 2.4.0]
// 32 - added "wrangler" permission [released 2.5.0]
// 33 - added "mkFileAsync" to generate a dummy file on server filesystem [released 2.5.1]
// 34 - added "send.updateSharedToken" and "updateAPIToken" to change token expiry date and description
//      added "minCipher" field in getServerInfo API; added 'calculateHashType' to 'ls' [released 2.6.0]
// 35 - added 'MD5' hash method for "lsAsync" 'caculateHashType' option
//    - added "lsListAsync" API for batch file listing
//    - added "recvApiVersion" field in transfer userdata
//    - added "setExternalAddress" API [released 2.6.4]
// 37 - added skip file errors during transfer
// 38 - updated "recvGetTransfers" API [released 2.8.3]
// 39 - added transferOrigin for Telemetry
// 40 - improved the lsAsync command for large directories
//" """
#undef __unused_constants_start
#undef __unused_permissions_start
#undef __unused_constants_end
#endif
