#!/usr/bin/env python
# encoding: utf-8
# Copyright 2017 Jet Digital Inc. All rights reserved.
#------------------------------------------------------------------------------------------------

import logging

class LoggingInterface(logging.Logger):

    __LOGGING_FORMAT = '%(asctime)s [%(levelname)s] %(message)s'
    __DATE_FORMAT = '%Y-%m-%d %H:%M:%S'

    def __init__(self):
        logging.Logger.__init__(self, 'jetstream', level=logging.DEBUG)
        if not self.handlers:
            self.setLevel(logging.DEBUG)
            formatter = logging.Formatter(LoggingInterface.__LOGGING_FORMAT, datefmt=LoggingInterface.__DATE_FORMAT)
            handler = logging.StreamHandler()
            handler.setLevel(logging.INFO)
            handler.setFormatter(formatter)
            self.addHandler(handler)
