#!/usr/bin/env python

from codecs import open
import os
from setuptools import setup

basedir = os.path.abspath(os.path.dirname(__file__))

with open(os.path.join(basedir, 'README.rst'), encoding='utf-8') as f:
    long_description = f.read()

try:
    with open(os.path.join(basedir, 'VERSION'), encoding='utf-8') as f:
        version = f.read().strip()
except:
    version = 'dev0.0.0'

setup(name='jetstream',
    version=version,

    description='Go:JetStream (JetStream) is a secure and fast file transfer system designed to operate over unreliable networks, such as the commodity internet.',
    long_description=long_description,

    author='Jet Digital Inc',
    author_email='support@gojetstream.io',

    url='http://gojetstream.io/',

    license='Proprietary',

    classifiers=[
        'License :: Other/Proprietary License',

        'Programming Language :: Python :: 2',
        'Programming Language :: Python :: 3',
    ],

    keywords='jetstream data transfer fast reliable secure',

    packages=['jetstream', 'jetstream.tools'],

    entry_points={
        'console_scripts': [
            'jscp = jetstream.tools.jscp:main',
        ]
    }
)
